#!/usr/bin/env python3
import os
import sys
import shutil
import zipfile
from glob import glob

def setup(local_dir="pymod_app" ):
    """
        Extract pymod_app code (and config) files into a local directory.
    """
    if not os.path.exists( local_dir ):
        os.mkdir( local_dir )
    os.chdir( local_dir )
    pkgdir = sys.modules['pymod_app'].__path__[0]

    for fullpath in glob( os.path.join( pkgdir, "*.json" ) ):
        shutil.copy(fullpath, os.getcwd())

    for fullpath in glob( os.path.join( pkgdir, "*.py" ) ):
        if os.path.basename(fullpath) == "bootstrap.py":
            continue
        shutil.copy(fullpath, os.getcwd())

    os.chdir( ".." )

if __name__ == "__main__":
    setup()

