#!/usr/bin/env python

import sys
import random
import dtk_hiv_intrahost as gi
from hiv_person import HivPerson
plot=False
ignore_signals = [ "EveryUpdate", "NewInfectionEvent", "HappyBirthday" ]

def subscribe_cb( signal, person ):
    print( "{person} wants to subscribe to {signal}" )

def unsubscribe_cb( signal, person ):
    print( "{person} wants to unsubscribe from {signal}" )

def publish_cb( signal, person ):
    if signal in ignore_signals:
        return
    print( f"SIGNAL...{signal}:{person}" )
    if signal=="STINewInfection":
        # GiveDelay
        import dtk_hivdelayed_iv as iv
        print( "Give Delay to Newly Infected." )
        individual_ptr = gi.get_individual_for_iv( person )
        iv.distribute( individual_ptr )
    elif signal=="HIVNewlyDiagnosed":
        # give some real interventions
        if random.random() < 0.1:
            print( "Give ART after delay." )
            import dtk_artbasic_iv as iv
            # This needs to be wrapped
            individual_ptr = gi.get_individual_for_iv( person )
            iv.distribute( individual_ptr )
        else:
            print( "Give VMMC after delay." )
            sex = gi.get_sex( person )
            if sex == 0: # sorry ladies, this one's only for the boys
                print( "...if male... (TBD)" )
                import dtk_malecirc_iv as iv
                #individual_ptr = gi.get_individual_for_iv( person )
                #iv.distribute( individual_ptr )
            else:
                print( "...unless female..." )
    elif signal=="STIDebut":
        print( "Give STI upon debut." )
        import dtk_modcoinf_iv as iv
        individual_ptr = gi.get_individual_for_iv( person )
        iv.distribute( individual_ptr )
    elif signal=="DiseaseDeaths":
        print( "Somebody died of HIV but they're not model-dead." )
        

gi.set_sub_cb( subscribe_cb )
gi.set_unsub_cb( unsubscribe_cb )
gi.set_pub_cb( publish_cb )

boy = HivPerson( 100.0, 0 )
girl = HivPerson( 100.0, 1 )

print( "\n*** TEST 3 ***\n" )
print( "Test HIV infection lifecycle via forced infection." )
import dtk_artbasic_iv as art
art_people = []
def infect_and_watch_die( person ):
    cd4s = []
    person.force_infect()
    #for t in range(0,365):
    updates = 0
    while person.dead() == False and updates < 10000:
        person.update()
        is_infected = person.infected()
        cd4 = person.cd4()
        """
        if cd4 < 100 and person not in art_people:
            print( "cd4 dropped below 100; distribute ART and expect CD4 to reconstitute." )
            individual_ptr = gi.get_individual_for_iv( person )
            art.distribute( individual_ptr )
            art_people.append( individual_ptr )
        """
        cd4s.append( cd4 )
        is_dead = person.dead()
        updates += 1
        #print( "Is infected? {0} CD4 {1}, Dead? {2}.".format( is_infected, cd4, is_dead  ) )
    return cd4s

cd4s = []
for _ in range(100): # Test 100 separate people
    boy = HivPerson( random.uniform( 0, 100 ), 0 )
    cd4s.append( infect_and_watch_die( boy ) )

